/*----------------------------------------------------------------------*/
/*	                     Saturn Morpion									*/
/*----------------------------------------------------------------------*/
#include	"sgl.h"
#include	"sega_sys.h"
#include	"croix.c"
#include	"croixPal.c"
#include	"rond.c"
#include	"rondPal.c"
#include	"back.c"
#include	"backPal.c"

#define		NBG1_CEL_ADR		( VDP2_VRAM_B1 + 0x02000 )
#define		NBG1_MAP_ADR		( VDP2_VRAM_B1 + 0x12000 )
#define		NBG1_COL_ADR		( VDP2_COLRAM + 0x00200 )
#define		BACK_COL_ADR		( VDP2_VRAM_A1 + 0x1fffe )
#define		PAD_NUM			13

static Uint16 pad_asign[] = {
	PER_DGT_KU,
	PER_DGT_KD,
	PER_DGT_KR,
	PER_DGT_KL,
	PER_DGT_TA,
	PER_DGT_TB,
	PER_DGT_TC,
	PER_DGT_ST,
	PER_DGT_TX,
	PER_DGT_TY,
	PER_DGT_TZ,
	PER_DGT_TR,
	PER_DGT_TL,
};

extern pad_cel[];
extern pad_map[];
extern pad_pal[];
extern TEXTURE tex_spr[];
extern PICTURE pic_spr[];
extern FIXED stat[][XYZS];
extern SPR_ATTR attr[];
extern ANGLE angz[];

int Board[9];



/*----------------------------------------------------------------------*/
		static void set_sprite(PICTURE *pcptr , Uint32 NbPicture)
{
	TEXTURE *txptr;
 
	for(; NbPicture-- > 0; pcptr++){
		txptr = tex_spr + pcptr->texno;
		slDMACopy((void *)pcptr->pcsrc,
			(void *)(SpriteVRAM + ((txptr->CGadr) << 3)),
			(Uint32)((txptr->Hsize * txptr->Vsize * 4) >> (pcptr->cmode)));
	}
}

/*----------------------------------------------------------------------*/
static void disp_sprite(int SpriteNo)
{
	
	slDispSprite((FIXED *)stat[SpriteNo], (SPR_ATTR *)(&attr[SpriteNo].texno), DEGtoANG(0));
	
}

/*----------------------------------------------------------------------*/
void CompPlay()
{
	int i;
	int val;
	char position;
	int Played;

	Played = 0;

	if(Board[5] == toFIXED(0.0))		
	{
		slBMPut(-16, 16,  15, -15, rond);
		Board[5] = toFIXED(2.0);
	}
	else
	{
		if(Board[7] == toFIXED(0.0))		
		{
			slBMPut(-48, -16, -17, -47, rond);
			Board[7] = toFIXED(2.0);
		}
		//  ajouter le code manquant
	}
}

/*----------------------------------------------------------------------*/
void CheckWinner()
{
	int PlayerWin;
	int SaturnWin;

	
	if( (SaturnWin!=toFIXED(1.0)) & ((Board[1]==toFIXED(1.0)) & (Board[2]==toFIXED(1.0)) & (Board[3]==toFIXED(1.0))) |
		((Board[4]==toFIXED(1.0)) & (Board[5]==toFIXED(1.0)) & (Board[6]==toFIXED(1.0))) |
		((Board[7]==toFIXED(1.0)) & (Board[8]==toFIXED(1.0)) & (Board[9]==toFIXED(1.0))) |
		((Board[1]==toFIXED(1.0)) & (Board[4]==toFIXED(1.0)) & (Board[7]==toFIXED(1.0))) |
		((Board[2]==toFIXED(1.0)) & (Board[5]==toFIXED(1.0)) & (Board[8]==toFIXED(1.0))) |
		((Board[3]==toFIXED(1.0)) & (Board[6]==toFIXED(1.0)) & (Board[9]==toFIXED(1.0))) |
		((Board[1]==toFIXED(1.0)) & (Board[5]==toFIXED(1.0)) & (Board[9]==toFIXED(1.0))) |
		((Board[3]==toFIXED(1.0)) & (Board[5]==toFIXED(1.0)) & (Board[7]==toFIXED(1.0))) 
	  )
	{
		PlayerWin = toFIXED(1.0);
		slPrint("YOU WIN", slLocate(5,8));
	}

	
	if( (PlayerWin!=toFIXED(1.0)) & ((Board[1]==toFIXED(2.0)) & (Board[2]==toFIXED(2.0)) & (Board[3]==toFIXED(2.0))) |
		((Board[4]==toFIXED(2.0)) & (Board[5]==toFIXED(2.0)) & (Board[6]==toFIXED(2.0))) |
		((Board[7]==toFIXED(2.0)) & (Board[8]==toFIXED(2.0)) & (Board[9]==toFIXED(2.0))) |
		((Board[1]==toFIXED(2.0)) & (Board[4]==toFIXED(2.0)) & (Board[7]==toFIXED(2.0))) |
		((Board[2]==toFIXED(2.0)) & (Board[5]==toFIXED(2.0)) & (Board[8]==toFIXED(2.0))) |
		((Board[3]==toFIXED(2.0)) & (Board[6]==toFIXED(2.0)) & (Board[9]==toFIXED(2.0))) |
		((Board[1]==toFIXED(2.0)) & (Board[5]==toFIXED(2.0)) & (Board[9]==toFIXED(2.0))) |
		((Board[3]==toFIXED(2.0)) & (Board[5]==toFIXED(2.0)) & (Board[7]==toFIXED(2.0))) 
	  )
	{
		SaturnWin = toFIXED(1.0);
		slPrint("SATURN WIN", slLocate(5,8));
	}

	if( (PlayerWin!=toFIXED(0.0)) & (SaturnWin!=toFIXED(0.0)) & 
		(Board[1]!=toFIXED(0.0)) & (Board[2]!=toFIXED(0.0)) & (Board[3]!=toFIXED(0.0)) &
		(Board[4]!=toFIXED(0.0)) & (Board[5]!=toFIXED(0.0)) & (Board[6]!=toFIXED(0.0)) &
		(Board[7]!=toFIXED(0.0)) & (Board[8]!=toFIXED(0.0)) & (Board[9]!=toFIXED(0.0))
	  )
	{
		slPrint("NO WINNER", slLocate(5,8));
	}

}
/*----------------------------------------------------------------------*/

void ss_main(void)
{
	Uint16 data;
	Sint32 posX, posY;
	
	slInitSystem(TV_320x224,tex_spr,1);
	slTVOff();
	set_sprite(pic_spr,2);

	slColRAMMode(CRM16_1024);
	slBack1ColSet((void *)BACK_COL_ADR , 0);

	slCharNbg1(COL_TYPE_256 , CHAR_SIZE_1x1);
	slPageNbg1((void *)NBG1_CEL_ADR , 0 , PNB_1WORD|CN_12BIT);
	slPlaneNbg1(PL_SIZE_1x1);
	slMapNbg1((void *)NBG1_MAP_ADR , (void *)NBG1_MAP_ADR , (void *)NBG1_MAP_ADR , (void *)NBG1_MAP_ADR);
	
	slInitBitMap(bmNBG1, BM_512x512, (void *)NBG1_CEL_ADR);
	slBMPaletteNbg1(1);

	//slBMPut( -96, -128,  159, 127, back);

	slScrPosNbg1(toFIXED(-32.0) , toFIXED(-36.0));
	slScrAutoDisp(NBG0ON | NBG1ON);
	slTVOn();

	posX = 0;
	posY = 0;
	
	Board[1] = toFIXED(0.0);
	Board[2] = toFIXED(0.0);
	Board[3] = toFIXED(0.0);
	Board[4] = toFIXED(0.0);
	Board[5] = toFIXED(0.0);
	Board[6] = toFIXED(0.0);
	Board[7] = toFIXED(0.0);
	Board[8] = toFIXED(0.0);
	Board[9] = toFIXED(0.0);

	while(1) 
	{
		if(!Per_Connect1) return;
		data = Smpc_Peripheral[0].data;

		if((data & pad_asign[0])==0)		
		{
			if((posY == toFIXED(0.0)) | (posY == toFIXED(1.0)) )
			{
				posY += toFIXED(1.0) ;
				stat[0][1] -= toFIXED(32.0);	
			}
		}
		
		if((data & pad_asign[1])==0)		
		{
			if((posY == toFIXED(1.0)) | (posY == toFIXED(2.0)) )
			{
				posY -= toFIXED(1.0) ;
				stat[0][1] += toFIXED(32.0);	
			}
		}

		if((data & pad_asign[2])==0)		
		{
			if((posX == toFIXED(0.0)) | (posX == toFIXED(1.0)) )
			{
				posX += toFIXED(1.0);
				stat[0][0] += toFIXED(32.0);	
			}
		}
		
		if((data & pad_asign[3])==0)		
		{
			if((posX == toFIXED(1.0)) | (posX == toFIXED(2.0)) )
			{
				posX -= toFIXED(1.0);
				stat[0][0] -= toFIXED(32.0);	
			}
		}

		if((data & pad_asign[4])==0)		
		{
			if( (posX == 0) & (posY == 0) )
			{
				if( Board[1]==toFIXED(0.0) )
				{
					slBMPut(-48, 48, -17,  17, croix);		
					Board[1] = toFIXED(1.0);
					CompPlay();
					CheckWinner();
				}
				else
				{
					slPrint("Can't go there", slLocate(5,8));
				}
			}
			
			if( (posX == toFIXED(1.0)) & (posY == 0) )
			{
				if( Board[2]==toFIXED(0.0) )
				{
					slBMPut(-16, 48,  15,  17, croix);
					Board[2] = toFIXED(1.0);
					CompPlay();
					CheckWinner();
				}
				else
				{
					slPrint("Can't go there", slLocate(5,8));
				}

			}
			
			if( (posX == toFIXED(2.0)) & (posY == 0))
			{
				if( Board[3]==toFIXED(0.0) ) 
				{
					slBMPut( 16, 48,  47,  17, croix);
					Board[3] = toFIXED(1.0);
					CompPlay();
					CheckWinner();
				}
				else
				{
					slPrint("Can't go there", slLocate(5,8));
				}
			}

			if( (posX == toFIXED(0.0)) & (posY == toFIXED(1.0)))
			{
				if( Board[4]==toFIXED(0.0) ) 
				{
					slBMPut(-48, 16, -17, -15, croix);
					Board[4] = toFIXED(1.0);
					CompPlay();
					CheckWinner();
				}
				else
				{
					slPrint("Can't go there", slLocate(5,8));
				}
			}

			if( (posX == toFIXED(1.0)) & (posY == toFIXED(1.0)))
			{
				if( Board[5]==toFIXED(0.0) ) 
				{
					slBMPut(-16, 16,  15, -15, croix);
					Board[5] = toFIXED(1.0);
					CompPlay();
					CheckWinner();
				}
				else
				{
					slPrint("Can't go there", slLocate(5,8));
				}
			}

			if( (posX == toFIXED(2.0)) & (posY == toFIXED(1.0)))
			{
				if( Board[6]==toFIXED(0.0) ) 
				{
					slBMPut( 16, 16,  47, -15, croix);
					Board[6] = toFIXED(1.0);
					CompPlay();
					CheckWinner();
				}
				else
				{
					slPrint("Can't go there", slLocate(5,8));
				}
			}

			if( (posX == toFIXED(0.0)) & (posY == toFIXED(2.0)))
			{
				if( Board[7]==toFIXED(0.0) ) 
				{
					slBMPut(-48, -16, -17, -47, croix);
					Board[7] = toFIXED(1.0);
					CompPlay();
					CheckWinner();
				}
				else
				{
					slPrint("Can't go there", slLocate(5,8));
				}
			}

			if( (posX == toFIXED(1.0)) & (posY == toFIXED(2.0)))
			{
				if( Board[8]==toFIXED(0.0) ) 
				{
					slBMPut(-16, -16,  15, -47, croix);
					Board[8] = toFIXED(1.0);
					CompPlay();
					CheckWinner();
				}
				else
				{
					slPrint("Can't go there", slLocate(5,8));
				}
			}

			if( (posX == toFIXED(2.0)) & (posY == toFIXED(2.0)))
			{
				if( Board[9]==toFIXED(0.0) ) 
				{
					slBMPut( 16, -16,  47, -47, croix);
					Board[9] = toFIXED(1.0);
					CompPlay();
					CheckWinner();
				}
				else
				{
					slPrint("Can't go there", slLocate(5,8));
				}

			}

		}

		slPrintFX(posX, slLocate(5,2));
		slPrintFX(posY, slLocate(5,4));
		disp_sprite(0);
		slSynch();
	} 
}

